/*
 * basic_apps.h
 *
 *  Created on: 26 Apr 2018
 *      Author: dadan
 */

#ifndef BASIC_APPS_H_
#define BASIC_APPS_H_

#include <avr/io.h>
#include "timers.h"
#include "canvas.h"
#include "epd_1_54.h"
#include "buttons.h"
#include "battery.h"

typedef struct
{
	uint8_t hours;
	uint8_t minutes;
	uint8_t seconds;
} time_t;

extern volatile time_t g_time;
extern time_t g_alarm_time;
extern uint8_t g_alarm_enabled;

void app_set_time(volatile time_t *time);
void app_status_screen(void);
void app_bluetooth();


void backlight_enable(uint8_t timeout);
void backlight_disable();

void alert_enable(uint8_t timeout);
void alert_disable();



#endif /* BASIC_APPS_H_ */
