/*
 * battery.h
 *
 *  Created on: 10 Nov 2018
 *      Author: dadan
 */

#ifndef BATTERY_H_
#define BATTERY_H_

#include <avr/io.h>

// Values for % of charge calculation
#define BATTERY_FULL_VALUE	651		// 4.2 V
#define BATTERY_EMPTY_VALUE	543		// 3.5 V

#define BATTERY_VOLTAGE_LOW		3500	// for low battery warning
#define BATTERY_VOLTAGE_DISCHARGED		3350	// for low battery warning

volatile uint16_t g_battery_voltage;

// initialize ADC
void battery_setup();

// start ADC conversion for battery voltage
void battery_start_measurement();

// get voltage in millivolts
uint16_t battery_get_voltage();

// get battery state in percents
uint8_t battery_get_percentage();

void battery_get_voltage_string(char str[], uint8_t len);

void battery_get_percentage_string(char str[], uint8_t len);

#endif /* BATTERY_H_ */
